###############################################################################
#	Copyright (C) 2007 by the Gang of 6 Pyweek4 Team		      #
#									      #
#									      #
#	This program is free software; you can redistribute it and#or modify  #
#	it under the terms of the GNU General Public License as published by  #
#	the Free Software Foundation; either version 2 of the License, or     #
#	(at your option) any later version.				      #
#									      #
#	This program is distributed in the hope that it will be useful,	      #
#	but WITHOUT ANY WARRANTY; without even the implied warranty of	      #
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the	      #
#	GNU General Public License for more details.			      #
#									      #
#	You should have received a copy of the GNU General Public License     #
#	along with this program; if not, write to the			      #
#	Free Software Foundation, Inc.,					      #
#	59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.	      #
###############################################################################

import pygame
from pygame.rect import Rect
from pygame.locals import *
import math
import random
from constants import *
import sys; sys.path.insert(0, "..")
import os

pygame.init()
screen = pygame.display.set_mode((SCREEN_WIDTH,SCREEN_HEIGHT),SWSURFACE)
texture = pygame.image.load(os.path.join(IMAGE_PATH, 'textures.png'))
fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),32)

MAP_WIDTH = 26 #static map width - should go in constants.py
MAP_HEIGHT = 18 #static map height - "
MAP_DEPTH = 5 #static map depth - "
MARKER = []
MAP_ARRAY = []
TILE_UNDEFINED = 0

global CURRENTx, CURRENTy
CURRENTx = 0
CURRENTy = 0

def clear_map(ARRAY):

	for x in range(MAP_WIDTH):
		ARRAY.append([])
		for y in range(MAP_HEIGHT):
			ARRAY[x].append([])
                        print x


def clear_world(ARRAY):
    
	for x in range(MAP_WIDTH):
		ARRAY.append([])
		for y in range(MAP_HEIGHT):
			ARRAY[x].append([])
			for z in range(MAP_DEPTH):
				ARRAY[x][y].append(TILE_UNDEFINED)


def start_return():
	
	MARKER[0][0] = 1


def blit_marker(x1,y1):

	screen.blit(fnt.render('+',1,(220,20,20)), (x1*32, y1*32))

def blit_layer():

	for x in range(MAP_WIDTH-1):
		for y in range(MAP_HEIGHT-1):
			for z in range(MAP_DEPTH-1):
                                MAP_ARRAY[x][y][0] = 5
				#this take the a given value and where it found it to determine what to blit and where.
				#the value in the given point determines the x value on the .png file it will load from
				#the z value will determine the y value on the .png it will load from
				#the x and y values determine where to blit it on the screen
				screen.blit(texture.subsurface((MAP_ARRAY[x][y][z]*32,(z*32),32,32)), ((32*x), (32*y), 32,32))
def find_character():

	for x in range(MAP_WIDTH):
		for y in range(MAP_HEIGHT):
			if MARKER[x][y] == 1:
				CURRENTx = x
				CURRENTy = y
			#print CURRENTx, CURRENTy


def find_key():
	for events in pygame.event.get():
		if events.type == KEYDOWN:
			if events.key == K_DOWN:
				move_marker(0,1)
			elif events.key == K_UP:
				move_marker(0,-1)
			elif events.key == K_LEFT:
				move_marker(-1,0)
			elif events.key == K_RIGHT:
				move_marker(1,0)
			elif events.key == K_ESCAPE:
				sys.exit()

def move_marker(x1,y1):
	global CURRENTx, CURRENTy
	#print CURRENTx
	CURRENTx += x1
	CURRENTy += y1
	#print CURRENTx, CURRENTy
 



clear_map(MARKER)
clear_world(MAP_ARRAY)
start_return()
while 1:
	find_character()
	find_key()
        screen.fill((0,0,0))
	blit_layer()
	blit_marker(CURRENTx,CURRENTy)
	pygame.display.flip()
