#################################################################################
#	Copyright (C) 2007 by the Gang of 6 Pyweek4 Team			#
#	Released under the GNU LGPL 2.1						#
#################################################################################

import pygame
import os
import pygame.font, pygame.event, pygame.draw, string
import random
from pygame.locals import *
from constants import *
from pgu import engine
from main import MusicVariable
import game as Game

class Menu(engine.State):
	def __init__(self,game):
		self.game = game
		
	def init(self):
		if self.game.sound == True:
			if MusicVariable.music_playing == False:
				pygame.mixer.music.load(os.path.join(MUSIC_PATH, "bellstrom2.ogg"))
				pygame.mixer.music.play(-1)
				MusicVariable.music_playing = True
		self.quit = False
		self.cur = 0
		self.menu = ['continue', 'back','reroll','quit'] 
		self.bkgr = pygame.image.load(os.path.join(IMAGE_PATH,"mainmenu.png")).convert()

		#self.logo = pygame.image.load(os.path.join(IMAGE_PATH,"mainmenu.png")).convert().convert_alpha()
		self.zones = []
		self.generateStats()
		self.current_string = []
	
	def generateStats(self):
		#Generate and compute core stats.
		random.seed()
		self.Str = random.randrange(10,18)
		self.Dex = random.randrange(10,18)
		self.Con = random.randrange(10,18)
		
	def calculateModifier(self, stat):
		#Calculate the modifier based on core stat.
		return int(round(((stat - 10) / 2) + 0.5))
	
	def calculateAC(self, dex):
		#Calculate the modifier based on dex.
		return ( 10 + dex )
	
	def calculateHP(self, con):
		#Calculate the modifier based on con.
		return ( 10 + con )
		
	def paint(self,screen):
		screen.fill((255,255,255))
		img = self.bkgr
		#img.set_alpha(128)
		screen.blit(img,(0,0))
		
		#img = self.logo
		
		bg = (0,0,0)
		y = 500
		x = 50
		#x = SW-img.get_width()
		#screen.blit(img,(x,y))
		
		fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),46)
		
		self.zones = []
		n = 0
		for val in self.menu:
			c = (22,59,130)
			if n == self.cur: c = (72,103,132)
			img = fnt.render(val,1,c)
			#img2 = fnt.render(val,1,bg)
			#x = (SW-img.get_width())/2
			#x = 50
			#screen.blit(img2,(x+2,y+2))
			screen.blit(img,(x,y))
			self.zones.append((n,pygame.Rect(x,y,img.get_width(),img.get_height())))
			x += 200
			n += 1
			
		#Display the statistics

		fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),32)
		display_box(screen, 160, 190, 80, 80, "IMG")
		display_box(screen, 300, 200, 400, 40, "Your Name: " + string.join(self.current_string,""))
		#STR
		screen.blit(fnt.render("STR: ", 1, (255,255,255)), (100, 300))
		display_box(screen, 180, 300, 40, 40, str(self.Str))
		screen.blit(fnt.render("Modifier: ", 1, (255,255,255)), (250, 300))
		display_box(screen, 370, 300, 40, 40, str(self.calculateModifier(self.Str)))
		#DEX
		screen.blit(fnt.render("DEX: ", 1, (255,255,255)), (100, 370))
		display_box(screen, 180, 370, 40, 40, str(self.Dex))
		screen.blit(fnt.render("Modifier: ", 1, (255,255,255)), (250, 370))
		display_box(screen, 370, 370, 40, 40, str(self.calculateModifier(self.Dex)))
		#CON
		screen.blit(fnt.render("CON: ", 1, (255,255,255)), (100, 440))
		display_box(screen, 180, 440, 40, 40, str(self.Con))
		screen.blit(fnt.render("Modifier: ", 1, (255,255,255)), (250, 440))
		display_box(screen, 370, 440, 40, 40, str(self.calculateModifier(self.Con)))
		#AC
		screen.blit(fnt.render("Armor Class:", 1, (255,255,255)), (510, 280))
		display_box(screen, 570, 330, 40, 40, str(self.calculateAC(self.Dex)))
		screen.blit(fnt.render("Hit Points:", 1, (255,255,255)), (525, 390))
		display_box(screen, 570, 440, 40, 40, str(self.calculateHP(self.Con)))
			
        	#fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),14)
		#y = 165
		#c = (211,215,250)
		
		pygame.display.flip()
		

		

	def event(self,e):
		if e.type is KEYDOWN and e.key == K_F2:
			if self.game.sound:
				self.game.music ^= 1
				pygame.mixer.music.set_volume(self.game.music)
			#return 1
		if e.type is KEYDOWN and (e.key == K_UP or e.key == K_LEFT):
			self.cur = (self.cur-1+len(self.menu))%len(self.menu)
			self.repaint()
		if e.type is KEYDOWN and (e.key == K_DOWN or e.key == K_RIGHT):
			self.cur = (self.cur+1+len(self.menu))%len(self.menu)
			self.repaint()
			
		if e.type is MOUSEMOTION:
			for n,rect in self.zones:
				if rect.collidepoint(e.pos):
					if self.cur != n:
						self.cur = n
						self.repaint()
									
		if (e.type is KEYDOWN and e.key in (K_RETURN,K_ESCAPE)) or (e.type is MOUSEBUTTONDOWN):
			val = self.menu[self.cur]
			if e.type is KEYDOWN and e.key == K_ESCAPE:
				val = 'quit'
			if val == 'back':
				import menu
				self.game.run(menu.Menu(self.game))
			if val == 'reroll':
				self.generateStats()
				self.repaint()
			if val == 'continue':
				if self.game.sound:
					pygame.mixer.music.stop()
					
				Game.main()
				self.repaint()
				
				if self.game.sound:
					pygame.mixer.music.play(-1)
				#return game.Game(self.game)
				
				#game.run(game.init())
				
			if val == 'quit':
				return engine.Quit(self.game)
			#if val == 'about':
				#return About(self.game)
		
		if (e.type is KEYDOWN):
			if e.key == K_BACKSPACE:
				self.current_string = self.current_string[0:-1]
			elif e.key == K_RETURN:
				self.playername = self.current_string
			elif e.key == K_MINUS:
				self.current_string.append("_")
			elif e.key <= 127:
				self.current_string.append(chr(e.key))
			#display_box(screen, 300, 200, 400, 40, "Your Name: " + string.join(current_string,""))
			self.repaint()



# by Timothy Downs, inputbox written for my map editor

# This program needs a little cleaning up
# It ignores the shift key
# And, for reasons of my own, this program converts "-" to "_"

# A program to get user input, allowing backspace etc
# shown in a box in the middle of the screen
# Called by:
# import inputbox
# answer = inputbox.ask(screen, "Your name")
#
# Only near the center of the screen is blitted to

def get_key():
	while 1:
		event = pygame.event.poll()
		if event.type == KEYDOWN:
			return event.key
		else:
			pass

def display_box(screen, x, y, w, h, message):
	"Print a message in a box in the middle of the screen"
	fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),32)
	pygame.draw.rect(screen, (0,0,0), (x, y, w, h), 0)
	pygame.draw.rect(screen, (255,255,255), (x-2, y-2, w+4, h+4), 1)
	if len(message) != 0:
		screen.blit(fnt.render(message, 1, (255,255,255)), (x+6, y))

def ask(screen, x, y, w, h, question):
	"ask(screen, question) -> answer"
	pygame.font.init()
	current_string = []
	display_box(screen, x, y, w, h, question + ": " + string.join(current_string,"") )
	while 1:
		inkey = get_key()
		if inkey == K_BACKSPACE:
			current_string = current_string[0:-1]
		elif inkey == K_RETURN:
			break
		elif inkey == K_MINUS:
			current_string.append("_")
		elif inkey <= 127:
			current_string.append(chr(inkey))
		display_box(screen, x, y, w, h, question + ": " + string.join(current_string,""))
	return string.join(current_string,"")