#################################################################################
#	Copyright (C) 2007 by the Gang of 6 Pyweek4 Team			#
#	Released under the GNU LGPL 2.1						#
#################################################################################

import pygame
from pygame.rect import Rect
from pygame.locals import *
import math
import random
from constants import *
import sys; sys.path.insert(0, "..")
import os

pygame.init()
screen = pygame.display.set_mode((SCREEN_WIDTH,SCREEN_HEIGHT),SWSURFACE)
texture = pygame.image.load(os.path.join(IMAGE_PATH, 'textures.png'))
fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),32)
fnt2 = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),12)


# Using globals for portability.
MAP_WIDTH = 26
MAP_HEIGHT = 18
MAP_DEPTH = 5


class Main:
	def __init__(self):
		self.MAP_WIDTH = 26 #static map width - should go in constants.py
		self.MAP_HEIGHT = 18 #static map height - "
		self.MAP_DEPTH = 5 #static map depth - "
		self.MARKER = []
		self.MAP_ARRAY = []
		self.LOGICAL_ARRAY = []
		self.TILE_UNDEFINED = 0

		self.CURRENTx = 0
		self.CURRENTy = 0
		
		self.character = False
		self.character_value_array1 = [None, None]
		self.character_value_array2 = [None, None]
		
		self.character_value1 = None
		self.character_value2 = None
		
		self.set_states = False
		
		self.set_items = False
		
		self.exit_block = False
		self.exit_block_pos = -1,-1 #Just to keep this off the screen even though it's always blitted
		
		self.player_block = False
		self.player_block_pos = -1,-2 #Just to keep this off the screen even though it's always blitted

		self.first_number_array = [None, None]
		self.second_number_array = [None, None]

		self.first_number = None
		self.second_number = None
		
	

	def clear_map(self, ARRAY):
	
		for x in range(self.MAP_WIDTH):
			ARRAY.append([])
			for y in range(self.MAP_HEIGHT):
				ARRAY[x].append([])
				#print x
	def clear_world(self, ARRAY):
	
		for x in range(self.MAP_WIDTH):
			ARRAY.append([])
			for y in range(self.MAP_HEIGHT):
				ARRAY[x].append([])
				for z in range(self.MAP_DEPTH):
					ARRAY[x][y].append(self.TILE_UNDEFINED)
	
	
	def start_return(self):
		
		self.MARKER[0][0] = 20
	
	
	def blit_marker(self,x1,y1):
		screen.blit(fnt.render('+',1,(220,20,20)), (x1*32, y1*32))
	
	def blit_layer(self):
	
		for x in range(self.MAP_WIDTH-1):
			for y in range(self.MAP_HEIGHT-1):
				for z in range(self.MAP_DEPTH-1):
					#self.MAP_ARRAY[x][y][0] = 1
					#this take the a given value and where it found it to determine what to blit and where.
					#the value in the given point determines the x value on the .png file it will load from
					#the z value will determine the y value on the .png it will load from
					#the x and y values determine where to blit it on the screen
					screen.blit(texture.subsurface((self.MAP_ARRAY[x][y][z]*32,(z*32),32,32)), ((32*x), (32*y), 32,32))
	def find_character(self):
	
		for x in range(self.MAP_WIDTH):
			for y in range(self.MAP_HEIGHT):
				if self.MARKER[x][y] == 1:
					self.CURRENTx = x
					self.CURRENTy = y
					#print self.CURRENTx, self.CURRENTy
					#print x, y
				
	
	
	def find_key(self):
		for events in pygame.event.get():
			if events.type == KEYDOWN:
				if events.key == K_DOWN:
					self.move_marker(0,1)

				elif events.key == K_UP:
					self.move_marker(0,-1)
				elif events.key == K_LEFT:
					self.move_marker(-1,0)
				elif events.key == K_RIGHT:
					self.move_marker(1,0)
				elif events.key == K_ESCAPE:
					sys.exit()
					
				elif events.key == K_1:
					if self.character == False:
						if self.set_states == True:
							self.LOGICAL_ARRAY[self.CURRENTx][self.CURRENTy][1] = 1
							self.set_states = False
						
						else:
							if self.first_number_array[1] != None:
								if self.second_number_array[0] == None:
									self.second_number_array[0] = 1
									continue
								if self.second_number_array[1] == None:
									self.second_number_array[1] = 1	
							else:
								if self.first_number_array[0] == None:
									self.first_number_array[0] = 1
									continue
							
								if self.first_number_array[1] == None:
									self.first_number_array[1] = 1
					
					
					if self.character == True:

						if self.character_value_array1[0] == None:
							self.character_value_array1[0] = 1
							continue
					
						if self.character_value_array1[1] == None:
							self.character_value_array1[1] = 1
							self.character = False
							
						
							
				elif events.key == K_2:
					if self.character == False:
						if self.first_number_array[1] != None:
							if self.second_number_array[0] == None:
								self.second_number_array[0] = 2
								continue
							if self.second_number_array[1] == None:
								self.second_number_array[1] = 2
							
							
						else:
							if self.first_number_array[0] == None:
								self.first_number_array[0] = 2
								continue
						
							if self.first_number_array[1] == None:
								self.first_number_array[1] = 2
							
					if self.character == True:
						if self.character_value_array1[0] == None:
							self.character_value_array1[0] = 2
							continue
					
						if self.character_value_array1[1] == None:
							self.character_value_array1[1] = 2
							self.character = False
						
							

							
				elif events.key == K_3:
					if self.character == False:
						if self.first_number_array[1] != None:
							if self.second_number_array[0] == None:
								self.second_number_array[0] = 3
								continue
							if self.second_number_array[1] == None:
								self.second_number_array[1] = 3
							
							
						else:
							if self.first_number_array[0] == None:
								self.first_number_array[0] = 3
								continue
						
							if self.first_number_array[1] == None:
								self.first_number_array[1] = 3
							
					if self.character == True:

						if self.character_value_array1[0] == None:
							self.character_value_array1[0] = 3
							continue
					
						if self.character_value_array1[1] == None:
							self.character_value_array1[1] = 3
							self.character = False

							
				elif events.key == K_4:
					if self.character == False:
						if self.first_number_array[1] != None:
							if self.second_number_array[0] == None:
								self.second_number_array[0] = 4
								continue
							if self.second_number_array[1] == None:
								self.second_number_array[1] = 4
							
							
						else:
							if self.first_number_array[0] == None:
								self.first_number_array[0] = 4
								continue
						
							if self.first_number_array[1] == None:
								self.first_number_array[1] = 4
							
							
					if self.character == True:

						if self.character_value_array1[0] == None:
							self.character_value_array1[0] = 4
							continue
					
						if self.character_value_array1[1] == None:
							self.character_value_array1[1] = 4
							self.character = False
						
							

							
				elif events.key == K_5:
					if self.character == False:
						if self.first_number_array[1] != None:
							if self.second_number_array[0] == None:
								self.second_number_array[0] = 5
								continue
							if self.second_number_array[1] == None:
								self.second_number_array[1] = 5
							
							
						else:
							if self.first_number_array[0] == None:
								self.first_number_array[0] = 5
								continue
						
							if self.first_number_array[1] == None:
								self.first_number_array[1] = 5
							
							
					if self.character == True:

							if self.character_value_array1[0] == None:
								self.character_value_array1[0] = 5
								continue
						
							if self.character_value_array1[1] == None:
								self.character_value_array1[1] = 5
								self.character = False

							

							
				elif events.key == K_6:
					if self.character == False:
						if self.first_number_array[1] != None:
							if self.second_number_array[0] == None:
								self.second_number_array[0] = 6
								continue
							if self.second_number_array[1] == None:
								self.second_number_array[1] = 6
							
							
						else:
							if self.first_number_array[0] == None:
								self.first_number_array[0] = 6
								continue
						
							if self.first_number_array[1] == None:
								self.first_number_array[1] = 6
							
					if self.character == True:

						if self.character_value_array1[0] == None:
							self.character_value_array1[0] = 6
							continue
					
						if self.character_value_array1[1] == None:
							self.character_value_array1[1] = 6
							self.character = False
							

							
				elif events.key == K_7:
					if self.character == False:
						if self.first_number_array[1] != None:
							if self.second_number_array[0] == None:
								self.second_number_array[0] = 7
								continue
							if self.second_number_array[1] == None:
								self.second_number_array[1] = 7
							
							
						else:
							if self.first_number_array[0] == None:
								self.first_number_array[0] = 7
								continue
						
							if self.first_number_array[1] == None:
								self.first_number_array[1] = 7
							
					if self.character == True:

						if self.character_value_array1[0] == None:
							self.character_value_array1[0] = 7
							continue
					
						if self.character_value_array1[1] == None:
							self.character_value_array1[1] = 7
							self.character = False
						
							
				elif events.key == K_8:
					if self.character == False:
						if self.first_number_array[1] != None:
							if self.second_number_array[0] == None:
								self.second_number_array[0] = 8
								continue
							if self.second_number_array[1] == None:
								self.second_number_array[1] = 8
							
							
						else:
							if self.first_number_array[0] == None:
								self.first_number_array[0] = 8
								continue
						
							if self.first_number[1] == None:
								self.first_number_array[1] = 8
							

					if self.character == True:
	
						if self.character_value_array1[0] == None:
							self.character_value_array1[0] = 8
							continue
					
						if self.character_value_array1[1] == None:
							self.character_value_array1[1] = 8
							self.character = False

						
				elif events.key == K_9: #Arf!
					if self.character == False:
						if self.first_number_array[1] != None:
							if self.second_number_array[0] == None:
								self.second_number_array[0] = 9
								continue
							if self.second_number_array[1] == None:
								self.second_number_array[1] = 9
							
							
						else:
							if self.first_number_array[0] == None:
								self.first_number_array[0] = 9
								continue
						
							if self.first_number_array[1] == None:
								self.first_number_array[1] = 9
							
					if self.character == True:

						if self.character_value_array1[0] == None:
							self.character_value_array1[0] = 9
							continue
					
						if self.character_value_array1[1] == None:
							self.character_value_array1[1] = 9
							self.character = False

							
				elif events.key == K_0:
					if self.character == False:
						if self.set_states == True:
							self.LOGICAL_ARRAY[self.CURRENTx][self.CURRENTy][1] = 0
							self.set_states = False
						
						else:
							if self.first_number_array[1] != None:
								if self.second_number_array[0] == None:
									self.second_number_array[0] = 0
									continue
								if self.second_number_array[1] == None:
									self.second_number_array[1] = 0
								
								
							else:
								if self.first_number_array[0] == None:
									self.first_number_array[0] = 0
									continue
							
								if self.first_number_array[1] == None:
									self.first_number_array[1] = 0
							
					if self.character == True:
						if self.character_value_array1[0] == None:
							self.character_value_array1[0] = 0
							continue
					
						if self.character_value_array1[1] == None:
							self.character_value_array1[1] = 0
							self.character = False

							
				elif events.key == K_c:
					self.character = True
					
				elif events.key == K_s:
					self.set_states = True
					
				elif events.key == K_i:
					self.set_items = True
					
				elif events.key == K_x:
					self.exit_block = True
					
				elif events.key == K_p:
					self.player_block = True
					
				elif events.key == K_F5:
					self.save_level()
				
				elif events.key == K_F6:
					
					self.load_level()
					self.blit_layer()
					pygame.display.flip()
					
					#for x in range(self.MAP_WIDTH-1):
					#	for y in range(self.MAP_HEIGHT-1):
					#		for z in range(self.MAP_DEPTH-1):
					#			self.MAP_ARRAY[x][y][0] = 7
					
					
				#[self.CURRENTx][self.CURRENTy][self.first_number] = second number
	
	def move_marker(self,x1,y1):
		#print self.CURRENTx
		self.CURRENTx += x1
		self.CURRENTy += y1
		#print self.CURRENTx, self.CURRENTy
		
	def update_MAP_ARRAY(self):
		if self.exit_block == True:
			self.LOGICAL_ARRAY[self.CURRENTx][self.CURRENTy][4] = self.first_number
			self.exit_block_pos = self.CURRENTx, self.CURRENTy
			self.exit_block = False
		
		if self.player_block == True:
			self.LOGICAL_ARRAY[self.CURRENTx][self.CURRENTy][0] = 1
			self.player_block_pos = self.CURRENTx, self.CURRENTy
			self.player_block = False
			
		else:
			if self.set_items == False:
				self.MAP_ARRAY[self.CURRENTx][self.CURRENTy][self.first_number] = self.second_number #update the map array.
			
			if self.set_items == True:
				#self.LOGICAL_ARRAY[self.CURRENTx][self.CURRENTy][3] = self.first_number
				self.LOGICAL_ARRAY[self.CURRENTx][self.CURRENTy][3] = self.load_chrData(self.first_number, 3)
				self.set_items = False
			
		
		
		# reset the values so that the editor doesn't place the tile on a new tile whenever the cursor is moved
		self.first_number_array = [None, None]
		self.second_number_array = [None, None]
	
		self.first_number = None
		self.second_number = None
		
	def update_LOGICAL_ARRAY(self):
		self.LOGICAL_ARRAY[self.CURRENTx][self.CURRENTy][0] = self.character_value1
		self.load_chrData(self.character_value1, 7)
		
		self.character_value_array1 = [None, None]
		self.character_value1 = None
		self.character = False
		
	def add_LOGICAL_to_MAP(self):
		for x in range(self.MAP_WIDTH):
			for y in range(self.MAP_HEIGHT):
				self.MAP_ARRAY[x][y][4] = self.LOGICAL_ARRAY[x][y][0]
				self.LOGICAL_ARRAY[self.CURRENTx][self.CURRENTy][1] = 1
		
		
	def check_numbers(self):
		try:
			if not self.first_number_array[0] == None:
				if not self.first_number_array[1] == None:
					self.first_number = int(str(self.first_number_array[0]) + str(self.first_number_array[1]))
	
		except TypeError:
			pass
					
		try:
			if not self.second_number_array[0] == None:
				if not self.second_number_array[1] == None:
					self.second_number = int(str(self.second_number_array[0]) + str(self.second_number_array[1]))
					self.update_MAP_ARRAY()
	
		except TypeError:
			pass
				
	
	def check_character_numbers(self):
		try:
			if not self.character_value_array1[1] == None:
				self.character_value1 = int(str(self.character_value_array1[0]) + str(self.character_value_array1[1]))
				self.update_LOGICAL_ARRAY()
				self.add_LOGICAL_to_MAP()
	
		except TypeError:
			pass
					
		#try:
			#if not self.character_value_array2[0] == None:
				#if not self.character_value_array2[1] == None:
					#self.character_value2 = int(str(self.character_value_array2[0]) + str(self.character_value_array2[1]))
					#self.update_LOGICAL_ARRAY()
	
		#except TypeError:
			#pass


	#LOGICAL_ARRAY[CURRENTx][CURRENTy][0] = inserted value
	
	def load_chrData(self, character_value, line):
		file_Handler = open(os.path.join(CHR_DATA, 'character%d.dat' % character_value), 'r')
		self.MAP_ARRAY[self.CURRENTx][self.CURRENTy][3] = int(file_Handler.readlines()[line])
		file_Handler.close()
		
	def save_level(self):
		import pickle
		
		map_array_Handler = file(os.path.join(LEVEL_DATA, 'map.dat'), 'w')
		logical_array_Handler = file(os.path.join(LEVEL_DATA, 'data.dat'), 'w')
		
		#for x in range(MAP_WIDTH):
			#for y in range(MAP_HEIGHT):
				#for z in range(MAP_DEPTH):
					#map_array_Handler.write(str(self.MAP_ARRAY[x][y][z]) + '\n')
		
		#for x in range(MAP_WIDTH):
			#for y in range(MAP_HEIGHT):
				#for z in range(MAP_DEPTH):
					#logical_array_Handler.write(str(self.LOGICAL_ARRAY[x][y][z]) + '\n')
		
		pickle.dump(self.MAP_ARRAY, map_array_Handler)
		pickle.dump(self.LOGICAL_ARRAY, logical_array_Handler)
		#map_array_Handler.write(self.MAP_ARRAY)
		#logical_array_Handler.write(self.LOGICAL_ARRAY)
		
		map_array_Handler.close()
		logical_array_Handler.close()
		
	def load_level(self):
		import pickle
		
		map_array_Handler = file(os.path.join(LEVEL_DATA, 'map.dat'), 'r')
		logical_array_Handler = file(os.path.join(LEVEL_DATA, 'data.dat'), 'r')
		
		#MAP_ARRAY = []
		#LOGICAL_ARRAY = []
		MAP_ARRAY = pickle.load(map_array_Handler)
		LOGICAL_ARRAY = pickle.load(logical_array_Handler)
		
		for x in range(self.MAP_WIDTH):
			for y in range(self.MAP_HEIGHT):
				for z in range(self.MAP_DEPTH):
					self.MAP_ARRAY[x][y][z] = MAP_ARRAY[x][y][z]
		
		for x in range(self.MAP_WIDTH):
			for y in range(self.MAP_HEIGHT):
				for z in range(self.MAP_DEPTH):
					self.LOGICAL_ARRAY[x][y][z] = LOGICAL_ARRAY[x][y][z]
		
		#print self.MAP_ARRAY
		#print self.LOGICAL_ARRAY
		
		map_array_Handler.close()
		logical_array_Handler.close()
		
		#return MAP_ARRAY, LOGICAL_ARRAY
	
	
	def main(self):
		self.clear_map(self.MARKER)
		self.clear_world(self.MAP_ARRAY)
		self.clear_world(self.LOGICAL_ARRAY)
		self.start_return()
		
		for x in range(self.MAP_WIDTH-1):
			for y in range(self.MAP_HEIGHT-1):
				for z in range(self.MAP_DEPTH-1):
					self.MAP_ARRAY[x][y][0] = 7

		while True:
			#print self.LOGICAL_ARRAY[self.CURRENTx][self.CURRENTy][4]
			
			self.find_character()		
			self.find_key()
			
			
			self.check_numbers()
			self.check_character_numbers()
			#print self.character_value_array1

			screen.fill((0,0,0))
			self.blit_layer()
			self.blit_marker(self.CURRENTx,self.CURRENTy)
			
			screen.blit(fnt2.render('exit',1,(220,20,20)), (self.exit_block_pos[0]*32, self.exit_block_pos[1]*32))
			
			screen.blit(fnt2.render('start',1,(220,20,20)), (self.player_block_pos[0]*32, self.player_block_pos[1]*32))
			
			pygame.display.flip()
			#print 101.first_number_array, self.self.second_number_array
			
			#pygame.time.wait(1000)
Main().main()
