#################################################################################
#	Copyright (C) 2007 by the Gang of 6 Pyweek4 Team			#
#	Released under the GNU LGPL 2.1						#
#################################################################################

import pygame
from pygame.rect import Rect
from pygame.locals import *
import math
import random
from constants import *
import sys; sys.path.insert(0, "..")
import os
from globals import *

# Function for saving character information.
def save_player(playerInfo):
	charName = playerInfo[0]
	fileItem = open(os.path.join(DATA_PATH, 'savegame.dat'), 'w')
	for x in range(30):
		fileItem.write( str(playerInfo[x]) + '\n' )
	fileItem.close()

# Function for loading character information.
def load_player():
	fileItem = open(os.path.join(DATA_PATH, 'savegame.dat'), 'r')
	for x in range(30):
		if x is not 0:
			playerData[x] = int(fileItem.readline())
		else:
			playerData[x] = fileItem.readline()
	fileItem.close()
	playerData[29] = 1
	#print "success!"
	#return character


# Function for loading level information.
#def load_level(INT_LEVELNUMBER):
	#fileHandle = open(os.path.join(LEVEL_DATA, "map" + str(INT_LEVELNUMBER) + ".dat"), "r")
	#for x in range(MAP_WIDTH):
		#for y in range(MAP_HEIGHT):
			#for z in range(MAP_DEPTH):
				#MAP_ARRAY[x][y][z] = int(fileHandle.readline())
	#fileHandle.close()
	#fileHandle = open(os.path.join(LEVEL_DATA, "data" + str(INT_LEVELNUMBER) + ".dat"), "r")
	#for x in range(MAP_WIDTH):
		#for y in range(MAP_HEIGHT):
			#for z in range(MAP_DEPTH):
				#LOGICAL_ARRAY[x][y][z] = int(fileHandle.readline())
	#fileHandle.close()


# Function for saving level information.
def save_level(INT_LEVELNUMBER):
	import pickle
	
	map_array_Handler = file(os.path.join(LEVEL_DATA, 'map'+str(INT_LEVELNUMBER)+'.dat'), 'w')
	logical_array_Handler = file(os.path.join(LEVEL_DATA, 'data'+str(INT_LEVELNUMBER)+'.dat'), 'w')
	
	#for x in range(MAP_WIDTH):
		#for y in range(MAP_HEIGHT):
			#for z in range(MAP_DEPTH):
				#map_array_Handler.write(str(self.MAP_ARRAY[x][y][z]) + '\n')
	
	#for x in range(MAP_WIDTH):
		#for y in range(MAP_HEIGHT):
			#for z in range(MAP_DEPTH):
				#logical_array_Handler.write(str(self.LOGICAL_ARRAY[x][y][z]) + '\n')
	
	pickle.dump(MAP_ARRAY, map_array_Handler)
	pickle.dump(LOGICAL_ARRAY, logical_array_Handler)
	#map_array_Handler.write(self.MAP_ARRAY)
	#logical_array_Handler.write(self.LOGICAL_ARRAY)
	
	map_array_Handler.close()
	logical_array_Handler.close()
		
def load_level(INT_LEVELNUMBER):
	import pickle
	
	map_array_Handler = file(os.path.join(LEVEL_DATA, 'map'+str(INT_LEVELNUMBER)+'.dat'), 'r')
	logical_array_Handler = file(os.path.join(LEVEL_DATA, 'data'+str(INT_LEVELNUMBER)+'.dat'), 'r')
	
	#MAP_ARRAY = []
	#LOGICAL_ARRAY = []
	tmpMAP_ARRAY = pickle.load(map_array_Handler)
	tmpLOGICAL_ARRAY = pickle.load(logical_array_Handler)
	
	for x in range(MAP_WIDTH):
		for y in range(MAP_HEIGHT):
			for z in range(MAP_DEPTH):
				MAP_ARRAY[x][y][z] = tmpMAP_ARRAY[x][y][z]
	
	for x in range(MAP_WIDTH):
		for y in range(MAP_HEIGHT):
			for z in range(MAP_DEPTH):
				LOGICAL_ARRAY[x][y][z] = tmpLOGICAL_ARRAY[x][y][z]
	
	#print self.MAP_ARRAY
	#print self.LOGICAL_ARRAY
	
	map_array_Handler.close()
	logical_array_Handler.close()

#def save_level(INT_LEVELNUMBER):
	#fileHandle = open("area" + str(INT_LEVELNUMBER) + ".dat", "a")
	#for x in range(MAP_WIDTH):
		#for y in range(MAP_HEIGHT):
			#for z in range(MAP_DEPTH):
				#fileHandle.write ('\n' + str(MAP_ARRAY[x][y][z]))
	#fileHandle.close()


# Function for laoding enemy information.
def load_enemy_data(enemyNumber, x, y, enemyType):
	itemNumber = 0
	fileData = open(os.path.join(CHR_DATA, "character" + str(enemyType) + ".dat"), "r")
	for itemNumber in range(8):
		if itemNumber is not 0:
			enemyData[enemyNumber][itemNumber] = int(fileData.readline())
		else:
			enemyData[enemyNumber][itemNumber] = fileData.readline()
	fileData.close()
	enemyData[enemyNumber][8] = x
	enemyData[enemyNumber][9] = y
	#print enemyData[enemyNumber]