#################################################################################
#	Copyright (C) 2007 by the Gang of 6 Pyweek4 Team			#
#	Released under the GNU LGPL 2.1						#
#################################################################################

import pygame
from pygame.rect import Rect
from pygame.locals import *
import math
import random
from constants import *
import sys; sys.path.insert(0, "..")
import os
from globals import *
import globals

from file_operations import *


def roll_die(dieNumber):
	return random.randrange(1,dieNumber)

#this function "defines" an array. Variable names can be inserted. It will either be MAP_ARRAY or LOGICAL_ARRAY
def clear_map2(ARRAY):
	
	for x in range(MAP_WIDTH):
		ARRAY.append([])
		for y in range(MAP_HEIGHT):
			ARRAY[x].append([])
			for z in range(MAP_DEPTH):
				ARRAY[x][y].append([])

def enemies_to_screen2(npcCount):
	for x in range(npcCount):
		#print x
		MAP_ARRAY[enemyData[x][8]][enemyData[x][9]][3] = LOGICAL_ARRAY[enemyData[x][8]][enemyData[x][9]][0]

def find_player(x1,y1):

	if x1 == 0 and y1 == 0: #no movement
		for x in range(MAP_WIDTH):
			for y in range(MAP_HEIGHT):
				#1 is the set value for the character (PC).
				if LOGICAL_ARRAY[x][y][0] == 1:
					globals.CURRENTx = x
					globals.CURRENTy = y
					MAP_ARRAY[globals.CURRENTx][globals.CURRENTy][3] = playerData[29]
	else:
		for x in range(MAP_WIDTH):
			for y in range(MAP_HEIGHT):
				#1 is the set value for the character (PC).
				if LOGICAL_ARRAY[x][y][0] == 1:
					globals.CURRENTx = x
					globals.CURRENTy = y
	if LOGICAL_ARRAY[globals.CURRENTx + x1][globals.CURRENTy + y1][1] == 0:
		MAP_ARRAY[globals.CURRENTx][globals.CURRENTy][3] = 0		
		LOGICAL_ARRAY[globals.CURRENTx + x1][globals.CURRENTy + y1][0] = 1
		LOGICAL_ARRAY[globals.CURRENTx][globals.CURRENTy][0] = 0
		MAP_ARRAY[globals.CURRENTx + x1][globals.CURRENTy + y1][3] = playerData[29]
	if LOGICAL_ARRAY[globals.CURRENTx + x1][globals.CURRENTy + y1][4] != 0:
		levelnum = LOGICAL_ARRAY[globals.CURRENTx + x1][globals.CURRENTy + y1][4]
		clear_map2(MAP_ARRAY)
		clear_map2(LOGICAL_ARRAY)
		load_level('0' + str(levelnum))
		npcCount = find_enemies(LOGICAL_ARRAY)
		enemies_to_screen2(npcCount)
		load_player()
		find_player(0,0)
		#print LOGICAL_ARRAY[globals.CURRENTx + x1][globals.CURRENTy + y1][4]



def make_enemy(count, x, y, type):
	enemyData.append([])
	for y in range(10):
		enemyData[count].append([])
	load_enemy_data(count, x, y, type)


def find_enemies(map):
	npcCount = 0
	for x in range(MAP_WIDTH):
		for y in range(MAP_HEIGHT):
			if map[x][y][0] > 1:
				make_enemy(npcCount, x, y, map[x][y][0])
				npcCount += 1
	return npcCount


def next_to_enemy():
	for x in range(MAP_WIDTH):
		for y in range(MAP_HEIGHT):
			#1 is the set value for the character (PC).
			if LOGICAL_ARRAY[x][y][0] == 1:
				globals.CURRENTx = x
				globals.CURRENTy = y
				#print "here we is"
	if LOGICAL_ARRAY[globals.CURRENTx + 1][globals.CURRENTy + 0][0] != 0:
		
		return True
	
	elif LOGICAL_ARRAY[globals.CURRENTx + 1][globals.CURRENTy + 1][0] != 0:
		
		return True

		
	elif LOGICAL_ARRAY[globals.CURRENTx + 0][globals.CURRENTy + 1][0] != 0:
			
		return True

		
	elif LOGICAL_ARRAY[globals.CURRENTx - 1][globals.CURRENTy + 1][0] != 0:
		
		return True
		
	elif LOGICAL_ARRAY[globals.CURRENTx - 1][globals.CURRENTy + 0][0] != 0:
		
		return True
		
	elif LOGICAL_ARRAY[globals.CURRENTx - 1][globals.CURRENTy - 1][0] != 0:
		
		return True
		
	elif LOGICAL_ARRAY[globals.CURRENTx + 1][globals.CURRENTy - 1][0] != 0:
		
		return True
		
	elif LOGICAL_ARRAY[globals.CURRENTx + 0][globals.CURRENTy - 1][0] != 0:
		
		return True
	return False
			

def find_key():
	for events in pygame.event.get():
		if events.type == KEYDOWN:
			if events.key == K_DOWN:
				find_player(0,1)
			elif events.key == K_UP:
				find_player(0,-1)
			elif events.key == K_LEFT:
				find_player(-1,0)
			elif events.key == K_RIGHT:
				find_player(1,0)
			elif events.key == K_ESCAPE:
				sys.exit()


def add_AC_mod(player):
	currentAC = player[3]
	currentAC += itemData[player[11] - 1][2]
	currentAC += itemData[player[12] - 1][2]
	return currentAC

def add_ATK_mod(player):
	currentATK = player[4]
	currentATK += itemData[player[10] - 1][2]
	return currentATK


def display_on_hud(text):
	pygame.draw.rect(screen, (0,0,0), (20,540,760,50), 0)
	message = hudfont.render(text, True, (200,200,200))
	screen.blit(message, (30, 545, 740, 40))


def exchange_punches(enemy):
	globals.playerData[2] -= 1
	print "battle begins!"