#################################################################################
#	Copyright (C) 2007 by the Gang of 6 Pyweek4 Team			#
#	Released under the GNU LGPL 2.1						#
#################################################################################

import pygame
import os

from pygame.locals import *
from constants import *
from pgu import engine
from main import MusicVariable
#import game as Game


class Menu(engine.State):
	def __init__(self,game):
		self.game = game
		
	def init(self):
		if self.game.sound == True:
			if MusicVariable.music_playing == False:
				pygame.mixer.music.load(os.path.join(MUSIC_PATH, "bellstrom2.ogg"))
				pygame.mixer.music.play(-1)
				MusicVariable.music_playing = True
		self.quit = False
		self.cur = 0
		self.menu = ['play', 'about','quit'] 
		self.bkgr = pygame.image.load(os.path.join(IMAGE_PATH,"mainmenu.png")).convert()
		#self.logo = pygame.image.load(os.path.join(IMAGE_PATH,"mainmenu.png")).convert().convert_alpha()
		self.zones = []
		
	def paint(self,screen):
		screen.fill((255,255,255))
		img = self.bkgr
		#img.set_alpha(128)
		screen.blit(img,(0,0))
		
		#img = self.logo
		
		bg = (0,0,0)
		y = 500
		x = 50
		#x = SW-img.get_width()
		#screen.blit(img,(x,y))
		
		fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),46)
		
		self.zones = []
		n = 0
		for val in self.menu:
			c = (22,59,130)
			if n == self.cur: c = (72,103,132)
			img = fnt.render(val,1,c)
			#img2 = fnt.render(val,1,bg)
			#x = (SW-img.get_width())/2
			#x = 50
			#screen.blit(img2,(x+2,y+2))
			screen.blit(img,(x,y))
			self.zones.append((n,pygame.Rect(x,y,img.get_width(),img.get_height())))
			x += 150
			n += 1
			
        	fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),14)
		y = 165
		c = (211,215,250)
		for line in ["(C) The Gang of 6 Pyweek4 Team", "Released under the GNU GPL v2"]:
			img = fnt.render(line,1,c)
			#img2 = fnt.render(line,1,bg)
			x = 500
			#screen.blit(img2,(x+2,y+2))
			screen.blit(img,(x,y))
			y += 14
			
		pygame.display.flip()
		

	def event(self,e):
		if e.type is KEYDOWN and e.key == K_F2:
			if self.game.sound:
				self.game.music ^= 1
				pygame.mixer.music.set_volume(self.game.music)
			#return 1
		if e.type is KEYDOWN and (e.key == K_UP or e.key == K_LEFT):
			self.cur = (self.cur-1+len(self.menu))%len(self.menu)
			self.repaint()
		if e.type is KEYDOWN and (e.key == K_DOWN or e.key == K_RIGHT):
			self.cur = (self.cur+1+len(self.menu))%len(self.menu)
			self.repaint()
			
		if e.type is MOUSEMOTION:
			for n,rect in self.zones:
				if rect.collidepoint(e.pos):
					if self.cur != n:
						self.cur = n
						self.repaint()
						
		if (e.type is KEYDOWN and e.key in (K_RETURN,K_ESCAPE)) or (e.type is MOUSEBUTTONDOWN):
			val = self.menu[self.cur]
			if e.type is KEYDOWN and e.key == K_ESCAPE:
				val = 'quit'
			if val == 'play':
				#if self.game.sound:
					#pygame.mixer.music.stop()
				#Game.main()
				import game_engine
				game_engine.main()
				#self.repaint()
				#return game.Game(self.game)
				
				#game.run(game.init())
				
			if val == 'quit':
				return engine.Quit(self.game)
			if val == 'about':
				return About(self.game)
			
			
class About(engine.State):
	def __init__(self,game):
		self.game = game
		
	def init(self):
		if self.game.sound == True:
			if MusicVariable.music_playing == False:
				pygame.mixer.music.load(os.path.join(MUSIC_PATH, "bellstrom2.ogg"))
				pygame.mixer.music.play(-1)
				MusicVariable.music_playing = True
		self.quit = False
		self.cur = 0
		self.menu = ['back','quit']
		self.credits1 = ["Programmers:",
		"Joseph Quigley (CPUFreak91)",
		"Kenny Yeager (Xian_Lee)",
		"Mike Wagman",
		"",
		"Music and Graphics:",
		"Ken Wagman"]
		
		self.credits2 = ["Sound Effects:",
		"Sam Washburne",
		"",
		"Project Leader, Designer,",
		"Level Designer, and Assisting Programmer:",
		"Brenton Keegan (IrishCream/Insanepoet)"]
		
		self.bkgr = pygame.image.load(os.path.join(IMAGE_PATH,"mainmenu.png")).convert()
		#self.logo = pygame.image.load(os.path.join(IMAGE_PATH,"mainmenu.png")).convert().convert_alpha()
		self.zones = []
		
	def paint(self,screen):
		screen.fill((255,255,255))
		img = self.bkgr
		#img.set_alpha(128)
		screen.blit(img,(0,0))
		
		#img = self.logo
		
		bg = (0,0,0)
		y = 500
		x = 50
		#x = SW-img.get_width()
		#screen.blit(img,(x,y))
		
		fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),46)
		
		self.zones = []
		n = 0
		for val in self.menu:
			c = (22,59,130)
			if n == self.cur: c = (72,103,132)
			img = fnt.render(val,1,c)
			#img2 = fnt.render(val,1,bg)
			#x = (SW-img.get_width())/2
			#x = 50
			#screen.blit(img2,(x+2,y+2))
			screen.blit(img,(x,y))
			self.zones.append((n,pygame.Rect(x,y,img.get_width(),img.get_height())))
			x += 150
			n += 1
			
		fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),20)
		
		n = 0
		x = 50
		y = 200
		for val in self.credits1:
			c = (22,59,130)
			img = fnt.render(val,1,c)
			#img2 = fnt.render(val,1,bg)
			#x = (SW-img.get_width())/2
			#x = 50
			#screen.blit(img2,(x+2,y+2))
			screen.blit(img,(x,y))
			y += 30
			n += 1
			
		n = 0
		x = 400
		y = 200
		for val in self.credits2:
			c = (22,59,130)
			img = fnt.render(val,1,c)
			#img2 = fnt.render(val,1,bg)
			#x = (SW-img.get_width())/2
			#x = 50
			#screen.blit(img2,(x+2,y+2))
			screen.blit(img,(x,y))
			y += 30
			n += 1
			
        	fnt = pygame.font.Font(os.path.join(DATA_PATH,"argos.ttf"),14)
		y = 165
		c = (211,215,250)
		for line in ["(C) The Gang of 6 Pyweek4 Team", "Released under the GNU GPL v2"]:
			img = fnt.render(line,1,c)
			#img2 = fnt.render(line,1,bg)
			x = 500
			#screen.blit(img2,(x+2,y+2))
			screen.blit(img,(x,y))
			y += 14
			
		pygame.display.flip()
		

	def event(self,e):
		if e.type is KEYDOWN and e.key == K_F2:
			if self.game.sound:
				self.game.music ^= 1
				pygame.mixer.music.set_volume(self.game.music)
			#return 1
		if e.type is KEYDOWN and (e.key == K_UP or e.key == K_LEFT):
			self.cur = (self.cur-1+len(self.menu))%len(self.menu)
			self.repaint()
		if e.type is KEYDOWN and (e.key == K_DOWN or e.key == K_RIGHT):
			self.cur = (self.cur+1+len(self.menu))%len(self.menu)
			self.repaint()
			
		if e.type is MOUSEMOTION:
			for n,rect in self.zones:
				if rect.collidepoint(e.pos):
					if self.cur != n:
						self.cur = n
						self.repaint()
						
		if (e.type is KEYDOWN and e.key in (K_RETURN,K_ESCAPE)) or (e.type is MOUSEBUTTONDOWN):
			val = self.menu[self.cur]
			if e.type is KEYDOWN and e.key == K_ESCAPE:
				val = 'quit'
			if val == 'back':
				return Menu(self.game)
				
			if val == 'quit':
				return engine.Quit(self.game)