###############################################################################
#	Copyright (C) 2007 by the Gang of 6 Pyweek4 Team			  #
#										  #
#										  #
#	This program is free software; you can redistribute it and#or modify  #
#	it under the terms of the GNU General Public License as published by  #
#	the Free Software Foundation; either version 2 of the License, or	 #
#	(at your option) any later version.					  #
#										  #
#	This program is distributed in the hope that it will be useful,		  #
#	but WITHOUT ANY WARRANTY; without even the implied warranty of		  #
#	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the		  #
#	GNU General Public License for more details.				  #
#										  #
#	You should have received a copy of the GNU General Public License	 #
#	along with this program; if not, write to the				  #
#	Free Software Foundation, Inc.,						  #
#	59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.		  #
###############################################################################

import pygame
from pygame.rect import Rect
from pygame.locals import *
from constants import *
import sys; sys.path.insert(0, "..")
import os
from globals import *
from file_operations import *
from mechanics import *

#this function "defines" an array. Variable names can be inserted. It will either be MAP_ARRAY or LOGICAL_ARRAY
def clear_map(ARRAY):
	
	for x in range(MAP_WIDTH):
		ARRAY.append([])
		for y in range(MAP_HEIGHT):
			ARRAY[x].append([])
			for z in range(MAP_DEPTH):
				ARRAY[x][y].append([])


#this function blits all graphic data to the screen
def blit_layer():
	
	for x in range(MAP_WIDTH-1):
		for y in range(MAP_HEIGHT-1):
			for z in range(MAP_DEPTH-1):
				#MAP_ARRAY[x][y][z] = random.randrange(1,15)	 
				#this take the a given value and where it found it to determine what to blit and where.
				#the value in the given point determines the x value on the .png file it will load from
				#the z value will determine the y value on the .png it will load from
				#the x and y values determine where to blit it on the screen
				screen.blit(texture.subsurface((MAP_ARRAY[x][y][z]*32,(z*32),32,32)), ((32*x), (32*y), 32,32))

def enemies_to_screen(npcCount):
	for x in range(npcCount):
		#print x
		MAP_ARRAY[enemyData[x][8]][enemyData[x][9]][3] = LOGICAL_ARRAY[enemyData[x][8]][enemyData[x][9]][0]


def make_item_list(numOfItems):
	x,y = 0,0
	for x in range(numOfItems):
		itemData.append([])
		for y in range(4):
			itemData[x].append([])


def load_item(itemNum):
	fileItem = open(os.path.join(DATA_PATH, "item" + str(itemNum) + '.dat'), 'r')
	itemNum = itemNum - 1
	for x in range(4):
		if x is not 0:
			itemData[itemNum][x] = int(fileItem.readline())
		else:
			itemData[itemNum][x] = fileItem.readline()
	fileItem.close()
	
#def enemy_attack():
	#playerData[2] -= 1
	
#def player_attack():
	#enemyData[4] -= 100
	
def main():
	clear_map(MAP_ARRAY)
	clear_map(LOGICAL_ARRAY)
	load_level(INT_LEVELNUMBER)
	npcCount = find_enemies(LOGICAL_ARRAY)
	enemies_to_screen(npcCount)
	load_player()
	find_player(0,0)
	#print playerData[29]
	alive = True
	battling = False
	while alive == True:
		#Pseudocode for main game loop.
		if battling == True:
			
			#print enemyData
		# Check to see if player is in an adjacent tile to an enemy.
		# If he is, then he is bound to fighting.
		#   In the context of fighting, all enemy movement stops, and a
		#   duel of the fates is carried out.  Player and enemy alternate attacks.
		#   If the player loses the fight, then alive is set to False
			if playerData[2] <= -10:
				alive = False
				print "Player Dying"
			#if enemyData[4] <= 0:
				#LOGICAL_ARRAY[0][y][0])
				#npcCount -= 1
			find_key()
			battling = False
			#HUDTEXT = "What do you want?"
		#	If the player wins the fight, then he gains experience.
		#if victorious == True:
		#	playerData[6] += enemyData[combatant][4]
		# If he is not, then he can continue adventuring as normal.
		else:
		# Because this is turn based no matter what, wait for input from the user.
			find_key()
		# Check to see if the player has entered a tile next to an enemy.
			if next_to_enemy() == True:
				battling = True
		
		# Render the updates.
		# Make sure the correct text (HUDTEXT in globals) is displayed.
		display_on_hud(HUDTEXT)
		# Send everything to the screen.
		blit_layer()
		# Flip the frame.
		pygame.display.flip()
		#alive = False
	print enemyData
	
main()